#version 150 compatibility

out vec3 N;
out vec2 TextureCoord;
out vec3 vertexPos;

in vec3 In_Normal;
in vec3 In_Vertex;
in vec2 In_TextureCoord;
uniform mat4 In_ViewMatrix;
uniform mat4 In_ProjectionMatrix;
uniform mat4 In_WorldMatrix;
uniform mat4 In_NormalMatrix;
uniform mat4 In_ViewProjectionMatrix;

void main() {
   
  
    N = /*gl_NormalMatrix */ In_Normal;//(In_NormalMatrix * vec4(In_Normal, 0.0)).xyz;
	vertexPos = In_Vertex;
	TextureCoord = In_TextureCoord;
	
    gl_Position =  In_ProjectionMatrix * In_ViewMatrix * In_WorldMatrix * vec4(In_Vertex, 1.0);
}
