uniform vec4 PatternSamples[500]; //PatternSamples


vec4 getSamplePosition(vec4 currentPos, float offset){

	return vec4(currentPos + vec4 (offset,0,0,0));
}


vec4 getSamplePosition(vec4 currentPos, vec2 offset){

	return vec4(currentPos + vec4 (offset , 0 , 0));
}

vec4 getSamplePosition(vec4 currentPos, vec3 offset){

	return vec4(currentPos + vec4 (offset, 0));
}

vec4 getSamplePosition(vec4 currentPos, vec4 offset){

	return vec4(currentPos + vec4 (offset));
}



vec4 getTextureProjectedSamplePosition(vec4 position, sampler2D PositionMap, mat4 In_ProjectionMatrix){
	vec4 projectedP = In_ProjectionMatrix * position;
	vec2 screen = (projectedP.xy / projectedP.w + vec2 (1) ) * 0.5;
	return texture (PositionMap,  screen);
}

//sampleFetch


vec4 getSampleUniform(const int index, vec4[500] PatternSamples){
	 return PatternSamples[index];
}


vec4 getSampleTexture(const int index, sampler2D SamplesTexture){
	int x = index % 200;
	int y = index / 200;
	return texelFetch(SamplesTexture,ivec2(x, y), 0);
}
// offset -1~~1
vec4 getSample(const int index, sampler2D SamplesTexture){

	return getSampleTexture(index, SamplesTexture);
	
	//return getSampleUniform(index, PatternSamples);
}



